#include "Gtk_AddTorusWindow.h"

using SigC::bind;
using SigC::slot;


AddTorusWindow::AddTorusWindow() :
  vbox1(false,0),
  vbox2(false,0),
  vbox3(false,0),
  hbox1(false,0),
  label1("Object to create:"),
  ok_label("Ok"),
  cancel_label("Cancel")
{
  set_title("Create a new object");
  add(vbox1);
  vbox1.pack_start(hbox1, false, false);
  hbox1.pack_start(label1, false, false);

  vbox1.pack_start(torus_params_frame, false, false);

  vbox1.pack_start(buttonbox1, false, false);
  buttonbox1.add(ok_button);
  ok_button.add(ok_label);
  ok_button.clicked.connect(bind<bool>(slot(this, &AddTorusWindow::quit_func), true));
  buttonbox1.add(cancel_button);
  cancel_button.add(cancel_label);
  cancel_button.clicked.connect(bind<bool>(slot(this, &AddTorusWindow::quit_func), false));
}



int AddTorusWindow::delete_event_impl(GdkEventAny* event) {
  hide_all();

  /* returnig true means the window won't be destroyed */
  return true;
}


// TODO: How can I send a delete event to the AddTorusWindow window?
void AddTorusWindow::delete_func() {
  //  delete_event();
}


void AddTorusWindow::quit_func(bool add_torus) {
  //TODO: Add functions in order to add the newly created torus to the queue
  // Also, add functions that check whether the entries are okay!
  if(add_torus) {
    add_torus_request();
  }

  hide_all();
  //  return add_torus;
}


Vector3 AddTorusWindow::get_normal() {
  return torus_params_frame.get_normal();
}

double AddTorusWindow::get_distance() {
  return torus_params_frame.get_distance();
}

drawmethod AddTorusWindow::get_draw_method() {
  return torus_params_frame.get_draw_method();
}

int AddTorusWindow::get_slicing_number() {
  return torus_params_frame.get_slicing_number();
}
