#ifndef GTK_ADDTORUSWINDOW
#define GTK_ADDTORUSWINDOW

#include <iostream>
#include <gtk--/window.h>
#include <gtk--/box.h>
#include <gtk--/frame.h>
#include <gtk--/label.h>
#include <gtk--/button.h>
#include <gtk--/buttonbox.h>

#include "CTorus.h"
#include "Gtk_TorusParamsFrame.h"

// TODO: Sollte es spter die Mglichkeit geben, zwischen der Erzeugung eines Torus und eines Kreises
// zu whlen, dann sollte aus dem Auswahlparameter-Frame eine eigene Klasse gemacht werden.

class AddTorusWindow : public Gtk::Window {
 public:
  AddTorusWindow();

 /** We don't want the widget to be destroyed when closed but to go inactive 
     and hide, so we override this method. */
  virtual int delete_event_impl(GdkEventAny* event);

  SigC::Signal0<void> add_torus_request;

  /* methods which provide access to the normal vector and the distance of the intersecting plane 
     as well as to the chosen drawing specifications */
  // TODO: Kann man diese Funktionen virtual machen oder sowas???
  Vector3 get_normal();
  double get_distance();
  drawmethod get_draw_method();
  int get_slicing_number();

 private:
  Gtk::VBox vbox1;
  Gtk::VBox vbox2;
  Gtk::VBox vbox3;
  Gtk::HBox hbox1;

  TorusParamsFrame torus_params_frame;

  Gtk::Label label1;

  Gtk::HButtonBox buttonbox1;
  Gtk::Button ok_button;
  Gtk::Button cancel_button;
  Gtk::Label ok_label;
  Gtk::Label cancel_label;

  void delete_func();
  void quit_func(bool );
};


#endif
