#include "Gtk_TorusParamsFrame.h"

using SigC::bind;
using SigC::slot;

/// bool TorusParamsFrame::torus_data_should_be_updated=true;


TorusParamsFrame::TorusParamsFrame() :
  Frame("Intersecting plane properties"),
  normal_frame("Directed normal vector"),
  distance_frame("Distance from origin"),
  draw_props_frame("Drawing properties"),
  draw_method_frame("Drawing method"),
  dp_rb_circs("Circles"),
  //  dp_rb_foliation("Foliated (not implemented yet!)"),
  dp_rb_foliation("Foliated"),
  dp_rb_mesh("Grid"),
  dp_rb_solid("Solid"),
  slicing_frame("Slicing"),
  table(5, 5, false),
  alpha_adjust(0, 0, 360, 1.0, 20, 0),
  //  beta_adjust (0, -90, 90, 1.0, 20, 0),
  beta_adjust (0, -180, 180, 1.0, 20, 0),
  alpha_scale(alpha_adjust),
  beta_scale(beta_adjust),
  alpha_spin(alpha_adjust),
  beta_spin(beta_adjust),

  normalx(6),
  normaly(6),
  normalz(6),

  distance_adjust(0, -1.0, 1.0, 0.001, 0.1, 0),
  distance_spin(distance_adjust, 0.005, 5),
  distance_scale(distance_adjust),

  slicing_adjust(60, 1, 100, 1, 10, 0), /* TODO: Ggf. grere Werte als 100 zulassen */
  slicing_spin(slicing_adjust, 1, 4),
  slicing_scale(slicing_adjust)
{
  add(vbox1);
  vbox1.pack_start(normal_frame, false, false);
  vbox1.pack_start(distance_frame, false, false);
  vbox1.pack_start(draw_props_frame, false, false);

  /* labels for the angles of the normal vector */
  Gtk::Label * label=manage(new Gtk::Label("alpha"));
  table.attach(*label, 0, 1, 0, 1);
  ll.push_back(label);
  label=manage(new Gtk::Label("beta"));
  table.attach(*label, 0, 1, 2, 3);
  ll.push_back(label);

  // TODO: Do these have to be dynamically allocated ??
  /*
  alpha_adjust=new Gtk::Adjustment(0, 0, 360, 1.0, 10, 10);
  beta_adjust=new Gtk::Adjustment (0, -90, 90, 1.0, 10, 10);
  */
  /*
  alpha_scale=new Gtk::HScale(*alpha_adjust);
  beta_scale=new Gtk::HScale(*beta_adjust);
  */
  alpha_scale.set_draw_value(true);
  beta_scale.set_draw_value(true);
  //  alpha_scale->set_update_policy(GTK_UPDATE_POLICY_DISCONTINUOUS);
  //  beta_scale->set_update_policy(GTK_UPDATE_POLICY_DISCONTINUOUS);
  alpha_scale.set_usize(180,-1);
  beta_scale.set_usize(180,-1);
  table.attach(alpha_scale, 1, 2, 1, 2);
  table.attach(beta_scale, 1, 2, 3, 4);
  

  /* labels for the coordinates of the normal vector */
  label=manage(new Gtk::Label("x"));
  table.attach(*label, 2, 3, 0, 1);
  ll.push_back(label);
  label=manage(new Gtk::Label("y"));
  table.attach(*label, 2, 3, 1, 2);
  ll.push_back(label);
  label=manage(new Gtk::Label("z"));
  table.attach(*label, 2, 3, 2, 3);
  ll.push_back(label);

  /* entries for the angles of the normal vector */
  /*
  Gtk::Entry * entry=manage(new Gtk::Entry());
  table.attach(*entry, 1, 2, 0, 1);
  el.push_back(entry);
  entry=manage(new Gtk::Entry());
  table.attach(*entry, 1, 2, 2, 3);
  el.push_back(entry);
  */
//  Gtk::Adjustment * test_adjust=new Gtk::Adjustment(0, 0, 0, 0, 10);

//  alpha_spin=manage(new Gtk::SpinButton(*alpha_adjust, 0.5, 5));
//  alpha_spin=manage(new Gtk::SpinButton());
//  alpha_spin=manage(new Gtk::SpinButton(alpha_adjust));

  alpha_spin.set_numeric(true);
  alpha_spin.set_wrap(true);
  alpha_spin.set_snap_to_ticks(true);
  alpha_spin.set_update_policy(GTK_UPDATE_IF_VALID);
//  cout << "Alpha_spin im Constructor: " <<  alpha_spin << endl;
  table.attach(alpha_spin, 1, 2, 0, 1);
//  el.push_back(alpha_spin);

//  test_adjust=new Gtk::Adjustment(0, 0, 0, 0, 10);
//  beta_spin=manage(new Gtk::SpinButton(*beta_adjust, 0.5, 5));
//  beta_spin=manage(new Gtk::SpinButton());
//  beta_spin=manage(new Gtk::SpinButton(beta_adjust));
  beta_spin.set_numeric(true);
  beta_spin.set_wrap(true);
  beta_spin.set_snap_to_ticks(true);
  beta_spin.set_update_policy(GTK_UPDATE_IF_VALID);
  table.attach(beta_spin, 1, 2, 2, 3);
//  el.push_back(beta_spin);


  //  alpha_spin->activate.connect(bind<bool >(slot(this, &TorusParamsFrame::on_entry_activated), false));
  alpha_adjust.value_changed.connect(slot(this, &TorusParamsFrame::on_angle_changed));
  beta_adjust.value_changed.connect(slot(this, &TorusParamsFrame::on_angle_changed));
  /*
  alpha_adjust.value_changed.connect(slot(this, &TorusParamsFrame::test_connect_func));
  */

  /* entries for the coordinates of the normal vector */
  /**** alt: ****
  Gtk::Entry * entry=manage(new Gtk::Entry());
  entry->set_text("1.0");
  entry->activate.connect(slot(this, &TorusParamsFrame::on_coord_changed));
  table.attach(*entry, 3, 4, 0, 1);
  el.push_back(entry);
  entry=manage(new Gtk::Entry());
  entry->set_text("0.0");
  entry->activate.connect(slot(this, &TorusParamsFrame::on_coord_changed));
  table.attach(*entry, 3, 4, 1, 2);
  el.push_back(entry);
  entry=manage(new Gtk::Entry());
  entry->set_text("0.0");
  entry->activate.connect(slot(this, &TorusParamsFrame::on_coord_changed));
  table.attach(*entry, 3, 4, 2, 3);
  el.push_back(entry);
  */
  normalx.set_text("1.0");
  normalx.activate.connect(slot(this, &TorusParamsFrame::on_coord_changed));
  table.attach(normalx, 3, 4, 0, 1);
  normaly.set_text("0.0");
  normaly.activate.connect(slot(this, &TorusParamsFrame::on_coord_changed));
  table.attach(normaly, 3, 4, 1, 2);
  normalz.set_text("0.0");
  normalz.activate.connect(slot(this, &TorusParamsFrame::on_coord_changed));
  table.attach(normalz, 3, 4, 2, 3);


  int spacing=10;
  /*
  table.set_row_spacing(0, spacing);
  table.set_row_spacing(1, spacing);
  table.set_row_spacing(2, spacing);
  table.set_row_spacing(3, spacing);
  */
  table.set_col_spacing(0, spacing);
  table.set_col_spacing(1, spacing);
  table.set_col_spacing(2, spacing);
  table.set_col_spacing(3, spacing);

  normal_frame.add(table);


  /* Distance widgets */
  distance_frame.add(hbox3);
  hbox3.pack_start(distance_spin);
  //  hbox3.pack_start(distance_scale);
  distance_spin.set_value(0.0);


  /* Drawing properties */
  draw_props_frame.add(hbox4);
  hbox4.pack_start(draw_method_frame);
  hbox4.pack_start(slicing_frame);

  draw_method_frame.add(vbox5);
  vbox5.pack_start(dp_rb_circs);
  vbox5.pack_start(dp_rb_foliation);
  vbox5.pack_start(dp_rb_mesh);
  vbox5.pack_start(dp_rb_solid);
  dp_rb_foliation.set_group(dp_rb_circs.group());
  dp_rb_mesh.set_group(dp_rb_circs.group());
  dp_rb_solid.set_group(dp_rb_circs.group());
  dp_rb_circs.set_active(true);

  /***************/
  /* connections */
  /***************/
  dp_rb_circs.pressed.connect(bind<drawmethod>(slot(this, &TorusParamsFrame::radio_button_pressed),CIRCS));
  dp_rb_foliation.pressed.connect(bind<drawmethod>(slot(this, &TorusParamsFrame::radio_button_pressed), FOLIATED));
  dp_rb_mesh.pressed.connect(bind<drawmethod>(slot(this, &TorusParamsFrame::radio_button_pressed), MESH));
  dp_rb_solid.pressed.connect(bind<drawmethod>(slot(this, &TorusParamsFrame::radio_button_pressed), SOLID));
  /***************/

  slicing_frame.add(vbox6);
  vbox6.pack_start(slicing_spin);
  vbox6.pack_start(slicing_scale);


  show_all();
}


  /*
  list<char* >::iterator i = strlist.begin();
  int j = 0;
  
  set_border_width(10);
  set_shadow_type(GTK_SHADOW_ETCHED_IN);
  set_label(*i);
  i++;
  
  hbox.set_spacing(4);

  Gtk::VBox* vbox1 = manage( new Gtk::VBox(false, 0));
  Gtk::VBox* vbox2 = manage( new Gtk::VBox(false, 0));
 
  vbox1->set_spacing(1);
  vbox1->set_border_width(2);
  vbox2->set_spacing(1);
  vbox2->set_border_width(2);
 
  for( ; i != strlist.end(); i++, j++) {

    Gtk::Label* label = manage( new Gtk::Label( *i));
    Gtk::Entry* entry = manage( new Gtk::Entry);

    entry->set_usize(entry_width, height);
    entry->set_max_length(length);
    entry->activate.connect(bind<int >(slot(this, &NormalParamsFrame::on_entry_activated), j));

    label->set_usize(-1, height);
    label->set_alignment(5, 0);



    ll.push_back( label);
    el.push_back( entry);
    vbox2->pack_start( *entry, false, false, 0);
    vbox1->pack_start( *label, false, false, 0);

  }

  hbox.pack_start( *vbox1, true, false, 0);
  hbox.pack_start( *vbox2, true, false, 0);

  add(hbox);
}
  */    


/* This method updates the angle or coordinate entries respectively,
   depending on the value of coord_activated (false means update coordinates, true means
   update angles */
/*
void TorusParamsFrame::on_entry_activated(bool coord_active) {
  char * tmpstr=new char(30);
  string tmpstring;
  Vector3 normal_vec;
  switch(coord_active) {
  case false:
    normal_vec=get_normal(true);
    cout << "Normal from angle: " << normal_vec << endl;

    gcvt(normal_vec[0], 30, tmpstr);
    tmpstring=string(tmpstr,10);
    el[2]->set_text(tmpstring);

    //    gcvt(normal_vec[1], 30, tmpstr);
    tmpstring=string(tmpstr,10);
    el[3]->set_text(tmpstring);

    //    gcvt(normal_vec[2], 30, tmpstr);
    tmpstring=string(tmpstr,10);
    el[4]->set_text(tmpstring);

    break;

  case true:
    normal_vec=get_normal(false);
    cout << "Normal from coordinates: " << normal_vec << endl;
    break;
  }
}
*/


void TorusParamsFrame::test_connect_func() {
  char * tmpstr=new char(30);
  int * decpt=new int;
  int * sign=new int;
  Vector3 normal_vec=get_normal(true);
  //  tmpstr=ecvt(normal_vec[0], 20, decpt, sign);
  sprintf(tmpstr, "%f", normal_vec[0]);
  cout << tmpstr << "*ggg*" << endl;
}

void TorusParamsFrame::on_angle_changed() {
  set_normal(get_normal(true));
  //  cout << "Hallo: " << TorusParamsWindow::cur->get_sect_plane().get_normal() << endl;
}


void TorusParamsFrame::on_coord_changed() {
  // TODO: Die Funktion von Fehlern beseitigen
  // TODO: Die Routine, die zu einem Vector3 die Winkel alpha und beta berechnet, evtl. in die Klasse "Vector3" selbst einbauen!!!
  // TorusParamsFrame::torus_data_should_be_updated=false;

  Vector3 tmp0=get_normal(false), tmp1=tmp0, tmp2=tmp1;
  tmp1[2]=0;
  tmp1=tmp1.normalize();
  double al=acos(tmp1[0]);
  if(sin(al)*tmp1[1]<0) {
    al=-al; /* choose the correct one among the two angles with the same cos */
  }
  al=al/M_PI*180;

  Vector3 up(0,0,1);
  tmp2=q_rotate(tmp2, -al, up);
  tmp2[1]=0;
  tmp2=tmp2.normalize();
  double bet=acos(tmp2[0]);
  if(sin(bet)*tmp2[2]<0) {
    bet=-bet; /* choose the correct (?) one among the two angles with the same cos */
  }
  bet=bet/M_PI*180;

  set_angles(al, bet);

  //  TorusParamsFrame::torus_data_should_be_updated=true;
  set_normal(tmp0.normalize());
}




// TODO: Is this function correct???
Vector3 TorusParamsFrame::get_normal(bool from_angle) {
  double al, bet;
  Vector3 tempvec;
  switch(from_angle) {
  case true:
    /*
    al=alpha_spin->get_value_as_float()*M_PI/180.0;
    bet=beta_spin->get_value_as_float()*M_PI/180.0;
    */
    al=alpha_adjust.get_value()*M_PI/180.0;
    bet=beta_adjust.get_value()*M_PI/180.0;
    tempvec=get_cartesian_vector_from_angles(al, bet);
    return tempvec;
    break;

  case false:
    tempvec=Vector3(atof(normalx.get_text().c_str()),
		    atof(normaly.get_text().c_str()),
		    atof(normalz.get_text().c_str()));
    return tempvec;
    break;
  }
}


double TorusParamsFrame::get_distance() {
  //  cout << "Distance: " << distance_spin.get_value_as_float() << endl;
  return distance_spin.get_value_as_float();
}

drawmethod TorusParamsFrame::get_draw_method() {
  if(dp_rb_circs.get_active()) {
    return CIRCS;
  };
  if(dp_rb_foliation.get_active()) {
    return FOLIATED;
  }
  if(dp_rb_mesh.get_active()) {
    return MESH;
  }
  if(dp_rb_solid.get_active()) {
    return SOLID;
  }
}


void TorusParamsFrame::set_draw_method(drawmethod method) {
  switch(method) {
  case CIRCS:
    dp_rb_circs.set_active(true);
    break;
  case FOLIATED:
    dp_rb_foliation.set_active(true);
    break;
  case MESH:
    dp_rb_mesh.set_active(true);
    break;
  case SOLID:
    dp_rb_solid.set_active(true);
    break;
  }
}


int TorusParamsFrame::get_slicing_number() {
  return (int) slicing_spin.get_value_as_float();
}


void TorusParamsFrame::set_slicing_number(int slnum) {
  slicing_spin.set_value(slnum);
}



// TODO: Sind die folgenden Funktionen korrekt?
// TODO: Wie lang mu der String wirklich sein? (30???)

void TorusParamsFrame::set_normal(Vector3 normal_vec) {
  char * tmpstr=new char(30);
  string tmpstring;

  sprintf(tmpstr, "%f", normal_vec[0]);
  tmpstring=string(tmpstr,10);
  normalx.set_text(tmpstring);

  sprintf(tmpstr, "%f", normal_vec[1]);
  tmpstring=string(tmpstr,10);
  normaly.set_text(tmpstring);
  
  sprintf(tmpstr, "%f", normal_vec[2]);
  tmpstring=string(tmpstr,10);
  normalz.set_text(tmpstring);
  /*
  pair<double,double> angles=normal_vec.get_polar_angles();
  alpha_adjust.set_value(angles.first);
  beta_adjust.set_value(angles.second);
  */
}


void TorusParamsFrame::set_angles(double alpha, double beta) {
  alpha_adjust.set_value(alpha);
  beta_adjust.set_value(beta);
  /*
  Vector3 normal_vec=get_cartesian_vector_from_angles(alpha, beta);
  char * tmpstr=new char(30);
  string tmpstring;

  sprintf(tmpstr, "%f", normal_vec[0]);
  tmpstring=string(tmpstr,10);
  normalx.set_text(tmpstring);

  sprintf(tmpstr, "%f", normal_vec[1]);
  tmpstring=string(tmpstr,10);
  normaly.set_text(tmpstring);
  
  sprintf(tmpstr, "%f", normal_vec[2]);
  tmpstring=string(tmpstr,10);
  normalz.set_text(tmpstring);
  */
}


void TorusParamsFrame::set_distance(double dist) {
  distance_spin.set_value(dist);
}



void TorusParamsFrame::radio_button_pressed(drawmethod meth) {
  //  cout << "Radio button number " << meth << " should have been clicked!" << endl;
  set_draw_method(meth);
}
