#ifndef HYPERSPHERE_VIEWER_H
#define HYPERSPHERE_VIEWER_H

/*
#include <stdio.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>

#include <gtk--/main.h>
#include <gtk--/toolbar.h>
#include <gtk--/button.h>
#include <gtk--/togglebutton.h>
#include <gtk--/radiobutton.h>
#include <gtk--/box.h>
#include <gtk--/window.h>
*/

#include <iostream>
#include <gtk--/toolbar.h>
#include <gtk--/combo.h>
#include <gtk--/button.h>
#include <gtk--/togglebutton.h>
#include <vector>
#include <string>
#include <map>
#include <algorithm>

#include "GenericViewer.h"
#include "SPlane3.h"
#include "CTorus.h"
#include "Gtk_AddTorusWindow.h"
#include "Gtk_TorusParamsWindow.h"


class HypersphereViewer: public GenericViewer
{
 public:
  HypersphereViewer();
  SigC::Signal0<gint> redraw_screen_request;
  // TODO: In welche Klasse soll das folgende Signal eingebaut werden???
  SigC::Signal0<void> redraw_torus_request; /* a signal which is emitted by the TorusParamsWindow */


 private:
  /** Virtual methods, both drawing and mouse handling, are overriden */
  virtual gint init_gl_context_imp();
  /** Virtual methods, both drawing and mouse handling, are overriden */
  virtual gint draw_gl_context_imp();

  /* Gtk::Combo Box showing the existing torus (and maybe circle) objects */
  Gtk::Combo torus_select_box;
  /* The entries in the box */
  // TODO: Why was there a segfault when using "string" instead of "char *" in the following line???
  vector<string> torus_select_entries;

  //  vector<CTorus*> existing_tori;
  map<string, CTorus*> existing_tori; /* contains the user-created tori */


  // TODO: How can this button be managed without pointers??? So far, there are segfaults etc. when I try it
  Gtk::ToggleButton params_window_button;
  Gtk::Button delete_torus_button; /* deletes the torus currently being shown in the combo box */
  Gtk::Button * add_torus_button; /* opens the "Add Torus" window which, surprisingly, lets the user define and add a new cyclide */
  AddTorusWindow add_torus_window;
  TorusParamsWindow torus_params_window;
  //  bool torus_params_window_visible; /*


  void add_new_torus(); /* is called when add_torus_button is pressed */
  void delete_torus(); /* is called when delete_torus_button is pressed */
  void toggle_params_window(); /* switches the state of the TorusParamsWindow */
  void update_current_torus(); /* updates the pointer "current_torus" and related data when the Combo box entry changes */
  void update_current_torus_stats(); /* updates the data of the current torus if values are changed in the parameter window */
  bool call_update_stats_upon_event;

  // TODO: Werden die folgenden beiden Variable gebraucht???
  //  vector<string>::iterator current_combo_entry; /* the current entry in the combo box */
  //  string selected_torus_string; /* the current entry in the combo box */


  //  vector<CTorus*>::iterator current_torus_iterator; /* an vector-iterator dereferencing a pointer to the current torus */
  CTorus* current_torus; /* an vector-iterator dereferencing a pointer to the torus currently being shown on the dropdown-list */
  string current_torus_name; /* the name of the current torus */

  //  CTorus * current_torus; /* a pointer to the torus currently shown in the combo box */
  unsigned int torus_number;

  Vector3 geradenrichtung;
  //  GLdouble rotwinkel;

};





const double a=2.0;
const double b=1.9;
const double d=0.7;
const double c=sqrt(a*a-b*b);

/*** Es folgen vier Kontrollpunktarrays, die jeweils die Kontrollpunkte fr die vier Bezier-Surfaces enthalten, die
 *** als Gesamtheit die Dupinsche Cyclide ergeben
 ***/
/*
GLfloat ctrlpts_aff00[3][3][4]={
  {{   a*d-a*a+c*c-c*d, 0, 0,            c-a}, {   a*d-a*a+c*c-c*d, b*d-b*a, 0,            c-a}, {-2*c*d, 2*b*d-2*b*a, 0, -2*a}},
  {{   a*d-a*a+c*c-c*d, 0, b*c-b*d,      c-a}, {   a*d-a*a+c*c-c*d, b*d-b*a, b*c-b*d,      c-a}, {-2*c*d, 2*b*d-2*b*a, -2*b*d, -2*a}},
  {{-2*a*a+2*c*c-2*c*d, 0, 2*b*c-2*b*d, -2*a}, {-2*a*a+2*c*c-2*c*d,  -2*b*a, 2*b*c-2*b*d, -2*a}, {-4*c*d, -4*b*a, -4*b*d, -4*a}}
};

GLfloat ctrlpts_aff01[3][3][4]={
  {{  -a*d+a*a-c*c-c*d, 0,  0,           -a-c}, {  -a*d+a*a-c*c-c*d, b*d-b*a,  0,           -a-c}, {-2*c*d, 2*b*d-2*b*a, 0, -2*a}},
  {{  -a*d+a*a-c*c-c*d, 0, -b*c-b*d,     -a-c}, {  -a*d+a*a-c*c-c*d, b*d-b*a, -b*c-b*d,     -a-c}, {-2*c*d, 2*b*d-2*b*a, -2*b*d, -2*a}},
  {{ 2*a*a-2*c*c-2*c*d, 0, -2*b*c-2*b*d, -2*a}, { 2*a*a-2*c*c-2*c*d,  -2*b*a, -2*b*c-2*b*d, -2*a}, {-4*c*d, -4*b*a, -4*b*d, -4*a}}
};

GLfloat ctrlpts_aff02[3][3][4]={
  {{  -a*d-a*a+c*c-c*d, 0, 0,           -a-c}, { -a*d-a*a+c*c-c*d, -b*d-b*a, 0,           -a-c}, {-2*c*d, -2*b*d-2*b*a,      0, -2*a}},
  {{  -a*d-a*a+c*c-c*d, 0, b*c-b*d,     -a-c}, { -a*d-a*a+c*c-c*d, -b*d-b*a, b*c-b*d,     -a-c}, {-2*c*d, -2*b*d-2*b*a, -2*b*d, -2*a}},
  {{-2*a*a+2*c*c-2*c*d, 0, 2*b*c-2*b*d, -2*a}, {-2*a*a+2*c*c-2*c*d,  -2*b*a, 2*b*c-2*b*d, -2*a}, {-4*c*d,       -4*b*a, -4*b*d, -4*a}}
};

GLfloat ctrlpts_aff03[3][3][4]={
  {{   a*d+a*a-c*c-c*d, 0, 0,            c-a}, {  a*d+a*a-c*c-c*d, -b*d-b*a, 0,            c-a}, {-2*c*d, -2*b*d-2*b*a,      0, -2*a}},
  {{   a*d+a*a-c*c-c*d, 0,-b*c-b*d,      c-a}, {  a*d+a*a-c*c-c*d, -b*d-b*a,-b*c-b*d,      c-a}, {-2*c*d, -2*b*d-2*b*a, -2*b*d, -2*a}},
  {{ 2*a*a-2*c*c-2*c*d, 0,-2*b*c-2*b*d, -2*a}, { 2*a*a-2*c*c-2*c*d,  -2*b*a,-2*b*c-2*b*d, -2*a}, {-4*c*d,       -4*b*a, -4*b*d, -4*a}}
};
*/


#endif
