#include "SPlane3.h"

SPlane3::SPlane3() {
    normal=Vector3(0,0,1);
    distance=0;
}


SPlane3::SPlane3(Vector3 n, double d) {
    normal=n.normalize(); // TODO: Ist Normalisierung notwendig?
    distance=d;
}


SPlane3::SPlane3(double alpha, double beta, double d) {
  double x,y,z,r;
  z=sin(beta);
  r=cos(beta);
  x=r*cos(alpha);
  y=r*sin(alpha);
  normal=Vector3(x,y,z).normalize();
  distance=d;
}



SPlane3::SPlane3(Vector3 P1, Vector3 P2, Vector3 P3) {
  normal=((P1-P2)^(P1-P3)).normalize(); // TODO: Ist Normalisierung notwendig?
  if(normal.abs()==0) {
    cerr << "The three points have to span the plane!" << endl;
    exit(1);
  }
  distance=P1*normal; // TODO: Stimmt diese Abstandsberechnung???
}


/**********************************
 *** Kann evtl. gelscht werden ***
 **********************************
pair<double, double> SPlane3::get_angles_of_normal() {
  double alpha, beta, r;
  if((r=sqrt(alpha*alpha+beta*beta))<0.00001) {
    return pair<double, double>(0,M_PI_2);
  }
  alpha=atan2(normal[2], normal[1]);
  beta=atan(normal[3]/r);
  return pair<double, double>(alpha,beta);
}
*/


void SPlane3::set_distance(double d) {
    /***
     *** TODO: Anfangs sollte diese Klasse nur Schnittebenen mit der S^2 modellieren, also war |d|<=1 erforderlich.
     ***       Nun macht es Sinn, auch andere Ebenen darstellen zu koennen. Daher wurde der folgende "Normierungsteil"
     ***       auskommentiert. Kann dies zu Laufzeitfehlern fuehren, weil eine Kontrolle wegfaellt???
     ***
    if(fabs(d)>1) {
	d=d/fabs(d);
	cerr << "Distance from origin of the plane is >1" << endl;
    }
    ***/
    distance=d;
}

double SPlane3::get_distance() {
    return distance;
}

void SPlane3::translate(double d_rel) {
    set_distance(distance+d_rel);
}

Circle3d SPlane3::get_intersecting_circle() {
    if (distance>1) {
	cerr << "The distance of the plane from the origin is >1. Therefore there is no intersection with S^2!" << endl;
    }
    Circle3d circle(normal.normalize()*distance, sqrt(1-distance*distance), normal);
    return circle;
}

// Calculates the intersecting circle of the plane with a sphere around "center" with radius "r"
// TODO: Zeigt der Normalenvektor in die richtige Richtung (d.h. auf die Ebene zu) ???
//       Arbeitet diese Funktion korrekt?
Circle3d SPlane3::get_intersecting_circle(Vector3 center, double r) {
    double d=distance-center*normal.normalize(); // d is the distance from the center of the sphere to the plane
    if(d>r) {
	cerr << "No intersection of the plane with the sphere..." << endl;
	cerr << "     d=" << d << "   r=" << r << "   d-r=" << d-r << endl;
    }
    double radius=sqrt(r*r-d*d);
    Circle3d circle(center+normal.normalize()*d, radius, normal);
    return circle;
}



double SPlane3::distance_from_point(Vector3 P) {
  return distance-P*normal; // TODO: Stimmt diese Abstandsberechnung???
}


Vector3 SPlane3::reflect(Vector3 P) {
  return P+normal*2*(distance-P*normal);
}
