#include "Vector3.h"

/* initialize static member data */
Vector3 Vector3::zero_vec=Vector3(0,0,0);
Vector3 Vector3::x_vec=Vector3(1,0,0);
Vector3 Vector3::y_vec=Vector3(0,1,0);
Vector3 Vector3::z_vec=Vector3(0,0,1);
Vector3 Vector3::neg_x_vec=Vector3(-1,0,0);
Vector3 Vector3::neg_y_vec=Vector3(0,-1,0);
Vector3 Vector3::neg_z_vec=Vector3(0,0,-1);


Vector3::Vector3() {}


Vector3::Vector3(double *ar) {
  for( int i = 0; i < 3; i++)
    vec[i] = ar[i];
}

Vector3::Vector3(double a, double b, double c){
  vec[0] = a;
  vec[1] = b;
  vec[2] = c;
}


pair<double, double> Vector3::get_polar_angles() {
  double alpha, beta, r;
  if((r=sqrt(vec[0]*vec[0]+vec[1]*vec[1]))<0.00001) {
    return pair<double, double>(0,M_PI_2);
  }
  alpha=atan2(vec[1], vec[0]);
  beta=atan(vec[2]/r);
  return pair<double, double>(alpha,beta);
}



bool Vector3::operator==(const Vector3 &q) const {
  for( int i = 0; i < 3; i++)
    if( vec[i] != q.vec[i])
      return false;
  return true;
}


bool Vector3::operator!=(const Vector3 &q) const {
  return !(*this == q);
}

Vector3& Vector3::operator=(const Vector3 &q) {
  for(int i = 0; i < 3; i++)
    vec[i] = q.vec[i];
}





double* Vector3::get_vec() const {
  double *ar = new double[3];
  for( int i = 0; i < 3; i++)
    ar[i] = vec[i];

  return ar;
}



Vector3 Vector3::normalize() {
    Vector3 tempvec=(*this);
    double norm=tempvec.abs();
    //cout << "Normalizing..." << endl << (*this) << endl;
    if(norm==0) {
	cerr << "Can't normalize. Norm=0..." << endl;
	return tempvec;
    }
    for(int i=0; i<3; i++) {
	tempvec[i]=tempvec[i]/norm;
    }
    //cout << "Normalized: " << endl << tempvec << endl;
    return tempvec;
}




ostream& operator<<(ostream &s, const Vector3&q) {
  double *v = q.get_vec();
  
  s << "( "<< v[0] << " , ";
  s << v[1] << " , ";
  s << v[2] << " ) ";

  
  return s;
}

