//was solln da nicht inline sein?

#ifndef VECTOR3_H
#define VECTOR3_H

#include <iostream.h>
#include <math.h>
#include <vector>

class Vector3 {
  double vec[3]; // Changed this from 4 to 3
  
 public:
  Vector3();
  Vector3(double *array);
  Vector3(double a, double b, double c);

  pair<double, double> get_polar_angles(); // returns the angles between the vector and the coordinate axes
  bool operator==(const Vector3 &q) const;
  bool operator!=(const Vector3 &q) const;
  Vector3& Vector3::operator=(const Vector3 &q);
  double operator*(const Vector3 &q) const; // scalar product
  Vector3& operator*(const double &s) const; // scalar multiplication
  Vector3& operator/(const double &s) const; // scalar multiplication
  Vector3& operator^(const Vector3 &q) const; // cross product
  Vector3& operator+(const Vector3 &q) const;
  Vector3& operator-(const Vector3 &q) const;
  Vector3& operator*=(const double &s);
  Vector3& operator+=(const Vector3 &q);
  double& operator[](int i);
  double abs() const;
  double* get_vec() const;
  Vector3 normalize();

  /* some often used vectors */
  static Vector3 zero_vec;
  static Vector3 x_vec;
  static Vector3 y_vec;
  static Vector3 z_vec;
  static Vector3 neg_x_vec;
  static Vector3 neg_y_vec;
  static Vector3 neg_z_vec;
};

// Liefert die Koordinaten eines Einheitsvektors, der durch alpha und beta (Polarkoordinaten) bestimmt ist
inline Vector3 get_cartesian_vector_from_angles(double alpha, double beta) {
  double r=cos(beta);
  return Vector3(r*cos(alpha),r*sin(alpha),sin(beta));
}


// returns the angle between vec1 and vec2 in radians
inline double v_angle(Vector3 vec1, Vector3 vec2) {
    double abs1=vec1.abs();
    double abs2=vec2.abs();
    if((abs1==0) || (abs2==0)) {
	//cerr << "Can't calculate angle between zero vector and another vector..." << endl;
	return 0;
    }
    return acos((vec1*vec2)/(abs1*abs2));
}


inline Vector3& Vector3::operator+=(const Vector3 &q) {
  Vector3 *res = new Vector3();

  for( int i = 0; i < 3; i++) 
    res->vec[i] = vec[i] + q.vec[i];

  *this = *res;
  delete res;
  return *this;
}

inline Vector3& Vector3::operator*=(const double &s) {
  Vector3 *res = new Vector3();
  res->vec[0] = vec[0]*s; 
  
  res->vec[1] = vec[1]*s;
    
  res->vec[2] = vec[2]*s;


  
  *this = *res;

  delete res;
  return *this;
}


inline Vector3& Vector3::operator*(const double &s) const {
  Vector3 *res = new Vector3();
  res->vec[0] = vec[0]*s ;
  res->vec[1] = vec[1]*s;
  res->vec[2] = vec[2]*s;
return *res;
}

inline Vector3& Vector3::operator/(const double &s) const {
  Vector3 *res = new Vector3();
  res->vec[0] = vec[0]/s ;
  res->vec[1] = vec[1]/s;
  res->vec[2] = vec[2]/s;
return *res;
}



inline double Vector3::operator*(const Vector3 &q) const {
  return  vec[0]*q.vec[0]+vec[1]*q.vec[1]+vec[2]*q.vec[2];
}

inline Vector3& Vector3::operator^(const Vector3 &q) const {
 Vector3 *res = new Vector3();
 res->vec[0]=vec[1]*q.vec[2]-vec[2]*q.vec[1];
 res->vec[1]=vec[2]*q.vec[0]-vec[0]*q.vec[2];
 res->vec[2]=vec[0]*q.vec[1]-vec[1]*q.vec[0];
 return *res;
}



inline Vector3& Vector3::operator+(const Vector3 &q) const {
  Vector3 *res = new Vector3();

  for( int i = 0; i < 3; i++) 
    res->vec[i] = vec[i] + q.vec[i];

  return *res;
}

inline Vector3& Vector3::operator-(const Vector3 &q) const {
  Vector3 *res = new Vector3();

  for( int i = 0; i < 3; i++) 
    res->vec[i] = vec[i] - q.vec[i];

  return *res;
}



inline double Vector3::abs() const {
  return sqrt(vec[0]*vec[0]
	      + vec[1]*vec[1]
	      + vec[2]*vec[2]);
}


inline double& Vector3::operator[](int i){
  return vec[i];
}



ostream& operator<<(ostream &s, const Vector3 &q);

#endif VECTOR3_H
