/*
 *  Gtk_ViewerToolbox.cc
 *
 *  Toolbox in GenericViewer
 *
 *  Copyright (C) 2002 Tobias Dyckerhoff
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#include "Gtk_ViewerToolbox.h"


using SigC::bind;
using SigC::slot;
using namespace Gtk::Toolbar_Helpers;

ViewerToolbox::ViewerToolbox() :campix("./pixmaps/camera.xpm")
{
  set_border_width(10);
  set_shadow_type(GTK_SHADOW_ETCHED_IN);
  set_label(" Viewer Tools");
  toolbar.tools().push_back(ButtonElem(campix,					  bind<int>(slot(this, &ViewerToolbox::tool_handler),1),"edit camera stats"));

  add(toolbar);

  set_usize(100,80);

  show_all();	
}

void ViewerToolbox::tool_handler(int id)
{
  tool_event(id);
}


